:- dynamic sentence80/5.
:- multifile sentence80/5.
:- public sentence80/5.
:- module_transparent sentence80/5.

sentence80(S, A, B, C, D) :-
    b_setval('$prev_w2s', []),
    b_setval('$prev_spans', []),
    sentence801(S, A, B, C, D).


:- dynamic sentence801/5.
:- multifile sentence801/5.
:- public sentence801/5.
:- module_transparent sentence801/5.

sentence801(_, A, B, C, D) :-
    if_giveup_dcg(A, B, C, D),
    !,
    fail.
sentence801(S, A, B, C, D) :-
    question80(S, A, E, C, F),
    (   terminator(?, E, B, F, D),
        !
    ;   noText(E, B, F, D)
    ).
sentence801(S, A, B, C, D) :-
    imperative80(S, A, E, C, F),
    (   terminator(!, E, B, F, D),
        !
    ;   noText(E, B, F, D)
    ).
sentence801(QS, A, B, C, D) :-
    s80(S, _, A, E, C, F),
    (   theText80(Punct, E, B, F, D)
    ;   noText(E, B, F, D),
        Punct=missing
    ),
    !,
    punct_to_sent_type(Punct, S, QS),
    !.


:- dynamic question80/5.
:- multifile question80/5.
:- public question80/5.
:- module_transparent question80/5.

question80(S, A, B, C, D) :-
    wh_question(S, A, B, C, D).
question80(S, A, B, C, D) :-
    yn_question(S, A, B, C, D).


:- dynamic declarative/5.
:- multifile declarative/5.
:- public declarative/5.
:- module_transparent declarative/5.

declarative(decl(S), A, B, C, D) :-
    s80(S, _, A, B, C, D).


:- dynamic wh_question/5.
:- multifile wh_question/5.
:- public wh_question/5.
:- module_transparent wh_question/5.

wh_question(whq(X, S), A, B, C, D) :-
    variable_q(X,
               _,
               QCase,
               NPCase,
               A,
               E,
               C,
               F),
    question80(QCase,
               NPCase,
               S,
               E,
               B,
               F,
               D).


:- dynamic np/11.
:- multifile np/11.
:- public np/11.
:- module_transparent np/11.

np(A, B, C, D, E, F, G, H, H, I, J) :-
    virtual(np(A, B, C, D, E, F, G),
            I,
            J).
np(AgmtKernelMods, Agmt, Case, Def, Role, Set, Mask, A, B, C, D) :-
    np0(AgmtKernelMods,
        Agmt,
        Case,
        Def,
        Role,
        Set,
        Mask,
        A,
        B,
        C,
        D).


:- dynamic variable_q/8.
:- multifile variable_q/8.
:- public variable_q/8.
:- module_transparent variable_q/8.

variable_q(X, Agmt, QCase, NPCase, A, B, C, x(gap, nonterminal, np(NP, Agmt, NPCase, _, _, Set, Mask), D)) :-
    whq(X,
        Agmt,
        NP,
        QCase,
        A,
        B,
        C,
        D),
    is_trace82(Set, Mask).
variable_q(X, Agmt, compl, CCase, A, B, C, x(gap, nonterminal, prep_phrase(prep_phrase(Prep, NP), compl, Set, Mask), D)) :-
    prep(Prep, A, E, C, F),
    whq(X, Agmt, NP, _, E, B, F, D),
    is_trace82(Set, Mask),
    is_compl_case(CCase).
variable_q(X, Agmt, compl, VCase, A, B, C, x(gap, nonterminal, adv_phrase(prep_phrase(Prep, np(Agmt, np_head(int_det(X), [], Noun), [])), Set, Mask), D)) :-
    context_pron(Prep, Noun, A, B, C, D),
    is_trace82(Set, Mask),
    is_verb_case(VCase).
variable_q(X, _, compl, VCase, A, B, C, x(gap, nonterminal, pred(adj, value80(Adj, wh(X)), Mask), D)) :-
    theText80(how, A, E, C, F),
    adj(quantV, Adj, E, B, F, D),
    is_empty_bits(Mask),
    is_verb_case(VCase).


:- dynamic prep_phrase/8.
:- multifile prep_phrase/8.
:- public prep_phrase/8.
:- module_transparent prep_phrase/8.

prep_phrase(A, B, C, D, E, E, F, G) :-
    virtual(prep_phrase(A, B, C, D), F, G).
prep_phrase(prep_phrase(Prep, Arg), Case, Set, Mask, A, B, C, D) :-
    prep(Prep, A, E, C, F),
    is_prep_case(NPCase),
    np(Arg,
       _,
       NPCase,
       _,
       Case,
       Set,
       Mask,
       E,
       B,
       F,
       D).


:- dynamic adv_phrase/7.
:- multifile adv_phrase/7.
:- public adv_phrase/7.
:- module_transparent adv_phrase/7.

adv_phrase(A, B, C, D, D, E, F) :-
    virtual(adv_phrase(A, B, C), E, F).
adv_phrase(prep_phrase(Prep, NP), Set, Mask, A, B, C, D) :-
    loc_pred(Of, Prep, A, E, C, F),
    prep_phrase(prep_phrase(prep(Of), NP),
                compl,
                Set,
                Mask,
                E,
                B,
                F,
                D).


:- dynamic pred/7.
:- multifile pred/7.
:- public pred/7.
:- module_transparent pred/7.

pred(A, B, C, D, D, E, F) :-
    virtual(pred(A, B, C), E, F).
pred(_, Adj, Mask, A, B, C, D) :-
    adj_phrase(Adj, Mask, A, B, C, D).
pred(negP(_Modal), PP, Mask, A, B, C, D) :-
    is_s_all(SAll),
    prep_phrase(PP,
                compl,
                SAll,
                Mask,
                A,
                B,
                C,
                D).
pred(_, Adv, Mask, A, B, C, D) :-
    is_s_all(SAll),
    adv_phrase(Adv,
               SAll,
               Mask,
               A,
               B,
               C,
               D).


:- dynamic whq/8.
:- multifile whq/8.
:- public whq/8.
:- module_transparent whq/8.

whq(X, Agmt, NP, undef, A, B, C, D) :-
    int_det(X, Agmt, A, E, C, F),
    is_s_all(SAll),
    np(NP,
       Agmt,
       _,
       _,
       subj,
       SAll,
       _,
       E,
       B,
       F,
       D).
whq(X, 3+No, np(3+No, wh(X), []), Case, A, B, C, D) :-
    int_pron(Case, A, B, C, D).


:- dynamic int_det/6.
:- multifile int_det/6.
:- public int_det/6.
:- module_transparent int_det/6.

int_det(X, 3+Agmt, A, B, C, D) :-
    whose(X, Agmt, A, B, C, D).
int_det(X, 3+Agmt, A, B, C, D) :-
    int_art_6(X, Agmt, A, B, C, D).


:- dynamic np_head0/7.
:- multifile np_head0/7.
:- public np_head0/7.
:- module_transparent np_head0/7.

np_head0(A, B, C, D, D, E, F) :-
    virtual(np_head0(A, B, C), E, F).
np_head0(nameOf(Name), 3+sg, def+proper, A, B, C, D) :-
    name_xg(Name, A, B, C, D).
np_head0(Pronoun, Agmt, def+proper, A, B, C, x(nogap, nonterminal, gen_marker, D)) :-
    poss_pron(Pronoun, Agmt, A, B, C, D).
np_head0(np_head(Det, [], Noun), 3+sg, indef+common, A, B, C, D) :-
    quantifier_pron(Det, Noun, A, B, C, D).
np_head0(np_head(Det, Adjs, Head), 3+Number, Def+common, A, B, C, D) :-
    determiner(Det,
               Number,
               Def,
               A,
               E,
               C,
               F),
    adjs_opt(Adjs, E, G, F, H),
    noun(Head, Number, G, B, H, D).


:- dynamic gen_marker/4.
:- multifile gen_marker/4.
:- public gen_marker/4.
:- module_transparent gen_marker/4.

gen_marker(A, A, B, C) :-
    virtual(gen_marker, B, C).
gen_marker(A, B, C, D) :-
    theText80('\'s', A, B, C, D),
    !.
gen_marker(A, B, C, D) :-
    theText80('\'', A, E, C, F),
    an_s(E, B, F, D).


:- dynamic whose/6.
:- multifile whose/6.
:- public whose/6.
:- module_transparent whose/6.

whose(X, Agmt, A, B, C, x(nogap, nonterminal, np_head0(wh(X), Agmt, proper), x(nogap, nonterminal, gen_marker, D))) :-
    theText80(whose, A, B, C, D).


:- dynamic question80/7.
:- multifile question80/7.
:- public question80/7.
:- module_transparent question80/7.

question80(QCase, NPCase, S, A, B, C, D) :-
    subj_question(QCase),
    is_to_role_case(subj, _, NPCase),
    s80(S, _, A, B, C, D).
question80(QCase, NPCase, S, A, B, C, D) :-
    fronted_verb(QCase, NPCase, A, E, C, F),
    s80(S, _, E, B, F, D).


:- dynamic det/7.
:- multifile det/7.
:- public det/7.
:- module_transparent det/7.

det(A, B, C, D, D, E, F) :-
    virtual(det(A, B, C), E, F).
det(det(Det), Number, Def, A, B, C, D) :-
    theText80(W, A, B, C, D),
    det_lex(W, Number, Det, Def).
det(generic, _, generic, A, B, C, D) :-
    noText(A, B, C, D).


:- dynamic int_art_6/6.
:- multifile int_art_6/6.
:- public int_art_6/6.
:- module_transparent int_art_6/6.

int_art_6(X, Agmt, A, B, C, x(nogap, nonterminal, det(DX, Agmt, def), D)) :-
    int_art(X, Agmt, DX, A, B, C, D).


:- dynamic yn_question/5.
:- multifile yn_question/5.
:- public yn_question/5.
:- module_transparent yn_question/5.

yn_question(q(S), A, B, C, D) :-
    fronted_verb(nil, _, A, E, C, F),
    s80(S, _, E, B, F, D).


:- dynamic verb_form88/9.
:- multifile verb_form88/9.
:- public verb_form88/9.
:- module_transparent verb_form88/9.

verb_form88(A, B, C, D, E, F, F, G, H) :-
    virtual(verb_form88(A, B, C, D, E),
            G,
            H).
verb_form88(MODAL, RootVerb, Tense, Agmt, Role, A, B, C, D) :-
    maybe_modal(W,
                MODAL,
                ModalInfo,
                A,
                E,
                C,
                F),
    !,
    verb_form88(MODAL,
                RootVerb,
                Tense,
                Agmt,
                Role,
                E,
                B,
                F,
                D),
    maybe_apply_modal(W, MODAL, ModalInfo, RootVerb).
verb_form88(_, RootVerb, Tense, Agmt, _Role, A, B, C, D) :-
    theText80_W2(W, L, A, B, C, D),
    verb_form_wlex(L, W, RootVerb, Tense, Agmt).


:- dynamic neg_modal_opt/7.
:- multifile neg_modal_opt/7.
:- public neg_modal_opt/7.
:- module_transparent neg_modal_opt/7.

neg_modal_opt(A, B, C, D, D, E, F) :-
    virtual(neg_modal_opt(A, B, C), E, F).
neg_modal_opt(MODAL, Aux, Neg, A, B, C, D) :-
    (   maybe_modal(W,
                    MODAL,
                    ModalInfo,
                    A,
                    E,
                    C,
                    F)
    ;   C=F,
        A=E
    ),
    neg_modal_opt1(MODAL,
                   Aux,
                   Neg,
                   E,
                   B,
                   F,
                   D),
    maybe_apply_modal(W, MODAL, ModalInfo, Neg).


:- dynamic fronted_verb/6.
:- multifile fronted_verb/6.
:- public fronted_verb/6.
:- module_transparent fronted_verb/6.

fronted_verb(QCase, NPCase, A, B, C, x(gap, nonterminal, verb_form88(MODAL, Root, Tense, Agmt, Role), x(nogap, nonterminal, neg_modal_opt(_, _, Neg), D))) :-
    verb_form88(MODAL,
                Root,
                Tense,
                Agmt,
                _,
                A,
                E,
                C,
                F),
    verb_type_lex(Root, aux+_),
    is_to_role_case(QCase, Role, NPCase),
    neg_modal_opt(MODAL,
                  _,
                  Neg,
                  E,
                  B,
                  F,
                  D).


:- dynamic imperative80/5.
:- multifile imperative80/5.
:- public imperative80/5.
:- module_transparent imperative80/5.

imperative80(imp(_U, _V, You, V, S), A, B, C, D) :-
    imperative_verb(You, V, A, E, C, F),
    s80(S, _, E, B, F, D).


:- dynamic theText80/5.
:- multifile theText80/5.
:- public theText80/5.
:- module_transparent theText80/5.

theText80(A, B, B, C, D) :-
    virtual(theText80(A), C, D).
theText80(IC, A, B, C, D) :-
    w1(W0, A, B, C, D),
    assertion((   nonvar(W0)
              ;   nonvar(IC)
              )),
    parser_e2c:the_text_unif(IC, W0).


:- dynamic imperative_verb/6.
:- multifile imperative_verb/6.
:- public imperative_verb/6.
:- module_transparent imperative_verb/6.

imperative_verb(You, Root, A, B, C, x(nogap, nonterminal, theText80(you), x(nogap, nonterminal, verb_form88(MODAL, Root, imp+fin, 2+sg, main), D))) :-
    verb_form88(MODAL,
                Root,
                inf,
                _,
                _,
                A,
                B,
                C,
                D),
    You=you.


:- dynamic s80/6.
:- multifile s80/6.
:- public s80/6.
:- module_transparent s80/6.

s80(s(Subj, Verb, Args, Mods), Mask, A, B, C, D) :-
    subj(Subj, Agmt, Type, A, E, C, F),
    s_vp(Subj,
         Agmt,
         Type,
         Verb,
         Args,
         Mods,
         Mask,
         E,
         B,
         F,
         D).


:- dynamic s_vp/11.
:- multifile s_vp/11.
:- public s_vp/11.
:- module_transparent s_vp/11.

s_vp(_Subj, Agmt, Type, Verb, Args, Mods, Mask, A, B, C, D) :-
    verb(Verb,
         Agmt,
         Type,
         Voice,
         A,
         E,
         C,
         F),
    is_empty_bits(Nil),
    is_s_all(SAll),
    verb_args(Type,
              Voice,
              Args,
              Nil,
              Mask0,
              E,
              G,
              F,
              H),
    minus_mask(SAll, Mask0, Set),
    plus_mask(SAll, Mask0, Mask1),
    verb_mods(Mods,
              Set,
              Mask1,
              Mask,
              G,
              B,
              H,
              D).


:- dynamic subj/7.
:- multifile subj/7.
:- public subj/7.
:- module_transparent subj/7.

subj(Subj, Agmt, O, A, B, C, D) :-
    subj0(Subj, Agmt, O, A, B, C, D).


:- dynamic subj0/7.
:- multifile subj0/7.
:- public subj0/7.
:- module_transparent subj0/7.

subj0(there, _Agmt, _+be(_MODAL), A, B, C, D) :-
    theText80(there, A, B, C, D).
subj0(Subj, Agmt, _, A, B, C, D) :-
    is_s_all(SAll),
    is_subj_case(Case),
    np(Subj,
       Agmt,
       Case,
       _,
       subj,
       SAll,
       _,
       A,
       B,
       C,
       D).


:- dynamic np0/11.
:- multifile np0/11.
:- public np0/11.
:- module_transparent np0/11.

np0(np(Agmt, Pronoun, []), Agmt, NPCase, def, _, Set, Nil, A, B, C, D) :-
    is_pp(Set),
    pers_pron(Pronoun,
              Agmt,
              Case,
              A,
              B,
              C,
              D),
    is_empty_bits(Nil),
    is_to_role_case(Case, decl, NPCase).
np0(np(Agmt, Kernel, Mods), Agmt, _Case, Def, Role, Set, Mask, A, B, C, D) :-
    is_pp(Set),
    np_head(Kernel,
            Agmt,
            Def+Type,
            PostMods,
            Mods,
            A,
            E,
            C,
            F),
    is_np_all(NPAll),
    np_compls(Type,
              Agmt,
              Role,
              PostMods,
              NPAll,
              Mask,
              E,
              B,
              F,
              D).
np0(part(Det, NP), 3+Number, _, indef, Role, Set, Mask, A, B, C, D) :-
    is_pp(Set),
    determiner(Det, Number, indef, A, E, C, F),
    theText80(of, E, G, F, H),
    is_s_all(SAll),
    is_prep_case(Case),
    np(NP,
       3+pl,
       Case,
       def,
       Role,
       SAll,
       Mask,
       G,
       B,
       H,
       D).


:- dynamic np_head/9.
:- multifile np_head/9.
:- public np_head/9.
:- module_transparent np_head/9.

np_head(Kernel, Agmt, Type, PostMods, Mods, A, B, C, D) :-
    np_head0(Kernel0,
             Agmt0,
             Type0,
             A,
             E,
             C,
             F),
    possessive(Kernel0,
               Agmt0,
               Type0,
               Mods0,
               Mods0,
               Kernel,
               Agmt,
               Type,
               PostMods,
               Mods,
               E,
               B,
               F,
               D).


:- dynamic np_compls/10.
:- multifile np_compls/10.
:- public np_compls/10.
:- module_transparent np_compls/10.

np_compls(proper, _, _, [], _, Nil, A, A, B, B) :-
    is_empty_bits(Nil).
np_compls(common, Agmt, Case, Mods, Set0, Mask, A, B, C, D) :-
    is_np_all(NPAll),
    np_mods(Agmt,
            Case,
            Rel,
            Mods,
            Set0,
            Set,
            NPAll,
            Mask0,
            A,
            E,
            C,
            F),
    relative(Agmt,
             Rel,
             Set,
             Mask0,
             Mask,
             E,
             B,
             F,
             D).


:- dynamic possessive/14.
:- multifile possessive/14.
:- public possessive/14.
:- module_transparent possessive/14.

possessive(Kernel0, Agmt0, _, [], Mods0, Kernel, Agmt, Type, PostMods, Mods, A, B, C, D) :-
    gen_case(A, E, C, F),
    np_head0(Kernel1,
             Agmt1,
             Type1,
             E,
             G,
             F,
             H),
    possessive(Kernel1,
               Agmt1,
               Type1,
               PostMods1,
               [ prep_phrase(poss, np(Agmt0, Kernel0, Mods0))
               | PostMods1
               ],
               Kernel,
               Agmt,
               Type,
               PostMods,
               Mods,
               G,
               B,
               H,
               D).
possessive(Kernel, Agmt, Type, PostMods, Mods, Kernel, Agmt, Type, PostMods, Mods, A, B, C, D) :-
    noText(A, B, C, D).


:- dynamic gen_case/4.
:- multifile gen_case/4.
:- public gen_case/4.
:- module_transparent gen_case/4.

gen_case(A, B, C, x(nogap, nonterminal, theText80(the), D)) :-
    gen_marker(A, B, C, D).


:- dynamic an_s/4.
:- multifile an_s/4.
:- public an_s/4.
:- module_transparent an_s/4.

an_s(A, B, C, D) :-
    textOpt([s], A, B, C, D).


:- dynamic determiner/7.
:- multifile determiner/7.
:- public determiner/7.
:- module_transparent determiner/7.

determiner(Det, Number, Def, A, B, C, D) :-
    det(Det, Number, Def, A, B, C, D).
determiner(Det, Number, Def, A, B, C, D) :-
    quant_phrase(Det,
                 Number,
                 Def,
                 A,
                 B,
                 C,
                 D).


:- dynamic quant_phrase/7.
:- multifile quant_phrase/7.
:- public quant_phrase/7.
:- module_transparent quant_phrase/7.

quant_phrase(quantV(Op, Quant), Number, Def, A, B, C, D) :-
    quantV(Op, Def, A, E, C, F),
    number(Quant, Number, E, B, F, D).


:- dynamic quantV/6.
:- multifile quantV/6.
:- public quantV/6.
:- module_transparent quantV/6.

quantV(Op, indef, A, B, C, D) :-
    neg_adv_opt(Op0, Op, A, E, C, F),
    comp_adv(Op0, E, G, F, H),
    theText80(than, G, B, H, D).
quantV(Op, indef, A, B, C, D) :-
    theText80(at, A, E, C, F),
    sup_adv(Adv, E, B, F, D),
    sup_op(Adv, Op).
quantV(the, def, A, B, C, D) :-
    theText80(the, A, B, C, D).
quantV(same, indef, A, B, C, D) :-
    noText(A, B, C, D).


:- dynamic neg_adv_opt/6.
:- multifile neg_adv_opt/6.
:- public neg_adv_opt/6.
:- module_transparent neg_adv_opt/6.

neg_adv_opt(Adv, not+Adv, A, B, C, D) :-
    theText80(not, A, B, C, D).
neg_adv_opt(Adv, Adv, A, B, C, D) :-
    noText(A, B, C, D).


:- dynamic np_mods/12.
:- multifile np_mods/12.
:- public np_mods/12.
:- module_transparent np_mods/12.

np_mods(Agmt, Case, Mods0, [Mod|Mods], Set0, Set, _, Mask, A, B, C, D) :-
    np_mod(Agmt,
           Case,
           Mod,
           Set0,
           Mask0,
           A,
           E,
           C,
           F),
    is_trace_bits(Trace),
    plus_mask(Trace, Mask0, Mask1),
    minus_mask(Set0, Mask1, Set1),
    plus_mask(Mask0, Set0, Mask2),
    np_mods(Agmt,
            Case,
            Mods0,
            Mods,
            Set1,
            Set,
            Mask2,
            Mask,
            E,
            B,
            F,
            D).
np_mods(_, _, Mods, Mods, Set, Set, Mask, Mask, A, B, C, D) :-
    noText(A, B, C, D).


:- dynamic np_mod/9.
:- multifile np_mod/9.
:- public np_mod/9.
:- module_transparent np_mod/9.

np_mod(_, Case, PP, Set, Mask, A, B, C, D) :-
    prep_phrase(PP,
                Case,
                Set,
                Mask,
                A,
                B,
                C,
                D).
np_mod(Agmt, _Case, WH, Set, Mask, A, B, C, D) :-
    reduced_relative(Agmt,
                     WH,
                     Set,
                     Mask,
                     A,
                     B,
                     C,
                     D).


:- dynamic verb_mods/8.
:- multifile verb_mods/8.
:- public verb_mods/8.
:- module_transparent verb_mods/8.

verb_mods([Mod|Mods], Set0, _, Mask, A, B, C, D) :-
    verb_mod(Mod, Set0, Mask0, A, E, C, F),
    is_trace_bits(Trace),
    plus_mask(Trace, Mask0, Mask1),
    minus_mask(Set0, Mask1, Set1),
    plus_mask(Mask0, Set0, Mask2),
    verb_mods(Mods,
              Set1,
              Mask2,
              Mask,
              E,
              B,
              F,
              D).
verb_mods([], _, Mask, Mask, A, B, C, D) :-
    noText(A, B, C, D).


:- dynamic verb_mod/7.
:- multifile verb_mod/7.
:- public verb_mod/7.
:- module_transparent verb_mod/7.

verb_mod(Adv, Set, Mask, A, B, C, D) :-
    adv_phrase(Adv, Set, Mask, A, B, C, D).
verb_mod(Adv, Set, Nil, A, B, C, D) :-
    is_adv_bits(Set),
    adverb(Adv, A, B, C, D),
    is_empty_bits(Nil).
verb_mod(PP, Set, Mask, A, B, C, D) :-
    prep_phrase(PP,
                compl,
                Set,
                Mask,
                A,
                B,
                C,
                D).


:- dynamic adjs_opt/5.
:- multifile adjs_opt/5.
:- public adjs_opt/5.
:- module_transparent adjs_opt/5.

adjs_opt([Adj|Adjs], A, B, C, D) :-
    pre_adj(Adj, A, E, C, F),
    adjs_opt(Adjs, E, B, F, D).
adjs_opt([], A, B, C, D) :-
    noText(A, B, C, D).


:- dynamic pre_adj/5.
:- multifile pre_adj/5.
:- public pre_adj/5.
:- module_transparent pre_adj/5.

pre_adj(Adj, A, B, C, D) :-
    adj(_, Adj, A, B, C, D).
pre_adj(Adj, A, B, C, D) :-
    sup_phrase(Adj, A, B, C, D).


:- dynamic sup_phrase/5.
:- multifile sup_phrase/5.
:- public sup_phrase/5.
:- module_transparent sup_phrase/5.

sup_phrase(sup(most, Adj), A, B, C, D) :-
    sup_adj(Adj, A, B, C, D).
sup_phrase(sup(Op, Adj), A, B, C, D) :-
    sup_adv(Op, A, E, C, F),
    adj(quantV, Adj, E, B, F, D).


:- dynamic comp_phrase/6.
:- multifile comp_phrase/6.
:- public comp_phrase/6.
:- module_transparent comp_phrase/6.

comp_phrase(comp(Comp, Adj, Arg), Mask, A, B, C, D) :-
    comp(Comp, Adj, A, E, C, F),
    is_np_no_trace(NPNT),
    is_prep_case(Case),
    np(Arg,
       _,
       Case,
       _,
       compl,
       NPNT,
       Mask,
       E,
       B,
       F,
       D).


:- dynamic comp/6.
:- multifile comp/6.
:- public comp/6.
:- module_transparent comp/6.

comp(Comp, Adj, A, B, C, D) :-
    comp_adv(Comp, A, E, C, F),
    adj(quantV, Adj, E, G, F, H),
    theText80(than, G, B, H, D).
comp(more, Adj, A, B, C, D) :-
    comp_adj(Adj, A, E, C, F),
    theText80(than, E, B, F, D).
comp(same, Adj, A, B, C, D) :-
    theText80(as, A, E, C, F),
    adj(quantV, Adj, E, G, F, H),
    theText80(as, G, B, H, D).


:- dynamic relative/9.
:- multifile relative/9.
:- public relative/9.
:- module_transparent relative/9.

relative(Agmt, [Rel], Set, _, Mask, A, B, C, D) :-
    is_pred(Set),
    rel_conj(Agmt,
             _Conj,
             Rel,
             Mask,
             A,
             B,
             C,
             D).
relative(_, [], _, Mask, Mask, A, B, C, D) :-
    noText(A, B, C, D).


:- dynamic rel_conj/8.
:- multifile rel_conj/8.
:- public rel_conj/8.
:- module_transparent rel_conj/8.

rel_conj(Agmt, Conj, Rel, Mask, A, B, C, D) :-
    rel(Agmt, Rel0, Mask0, A, E, C, F),
    rel_rest(Agmt,
             Conj,
             Rel0,
             Rel,
             Mask0,
             Mask,
             E,
             B,
             F,
             D).


:- dynamic rel_rest/10.
:- multifile rel_rest/10.
:- public rel_rest/10.
:- module_transparent rel_rest/10.

rel_rest(Agmt, Conj0, Rel0, Rel, _, Mask, A, B, C, D) :-
    conj(Conj0,
         Conj,
         Rel0,
         Rel1,
         Rel,
         A,
         E,
         C,
         F),
    rel_conj(Agmt,
             Conj,
             Rel1,
             Mask,
             E,
             B,
             F,
             D).
rel_rest(_, _, Rel, Rel, Mask, Mask, A, B, C, D) :-
    noText(A, B, C, D).


:- dynamic rel/7.
:- multifile rel/7.
:- public rel/7.
:- module_transparent rel/7.

rel(Agmt, rel(X, S), Mask, A, B, C, D) :-
    mark_island(A, E, C, F),
    variable(Agmt, X, E, G, F, H),
    s80(S, Mask0, G, I, H, J),
    is_trace_bits(Trace),
    minus_mask(Mask0, Trace, Mask),
    mark_dnalsi(I, B, J, D).


:- dynamic variable/6.
:- multifile variable/6.
:- public variable/6.
:- module_transparent variable/6.

variable(Agmt, X, A, B, C, x(gap, nonterminal, np(np(Agmt, wh(X), []), Agmt, _, _, _, Set, Mask), D)) :-
    theText80(that, A, B, C, D),
    is_trace82(Set, Mask).
variable(Agmt0, X, A, B, C, x(gap, nonterminal, np(NP, Agmt, NPCase, _, _, Set, Mask), D)) :-
    wh(X,
       Agmt0,
       NP,
       Agmt,
       NPCase,
       A,
       B,
       C,
       D),
    is_trace82(Set, Mask).
variable(Agmt0, X, A, B, C, x(gap, nonterminal, prep_phrase(prep_phrase(Prep, NP), compl, Set, Mask), D)) :-
    prep(Prep, A, E, C, F),
    wh(X,
       Agmt0,
       NP,
       _Agmt,
       Case,
       E,
       B,
       F,
       D),
    is_trace82(Set, Mask),
    is_compl_case(Case).


:- dynamic wh/9.
:- multifile wh/9.
:- public wh/9.
:- module_transparent wh/9.

wh(X, Agmt, np(Agmt, wh(X), []), Agmt, NPCase, A, B, C, D) :-
    rel_pron(Case, A, B, C, D),
    is_to_role_case(Case, decl, NPCase).
wh(X, Agmt0, np(Agmt, Kernel, [prep_phrase(Prep, NP)]), Agmt, _, A, B, C, D) :-
    np_head0(Kernel,
             Agmt,
             _+common,
             A,
             E,
             C,
             F),
    prep(Prep, E, G, F, H),
    wh(X,
       Agmt0,
       NP,
       _,
       _,
       G,
       B,
       H,
       D).
wh(X, Agmt0, NP, Agmt, Case, A, B, C, D) :-
    whose(X, Agmt0, A, E, C, F),
    is_s_all(SAll),
    np(NP,
       Agmt,
       Case,
       def,
       subj,
       SAll,
       _,
       E,
       B,
       F,
       D).


:- dynamic reduced_relative/8.
:- multifile reduced_relative/8.
:- public reduced_relative/8.
:- module_transparent reduced_relative/8.

reduced_relative(Agmt, Rel, Set, Mask, A, B, C, D) :-
    is_pred(Set),
    reduced_rel_conj(Agmt,
                     _Conj,
                     Rel,
                     Mask,
                     A,
                     B,
                     C,
                     D).


:- dynamic reduced_rel_conj/8.
:- multifile reduced_rel_conj/8.
:- public reduced_rel_conj/8.
:- module_transparent reduced_rel_conj/8.

reduced_rel_conj(Agmt, Conj, Rel, Mask, A, B, C, D) :-
    reduced_rel(Agmt,
                Rel0,
                Mask0,
                A,
                E,
                C,
                F),
    reduced_rel_rest(Agmt,
                     Conj,
                     Rel0,
                     Rel,
                     Mask0,
                     Mask,
                     E,
                     B,
                     F,
                     D).


:- dynamic reduced_rel_rest/10.
:- multifile reduced_rel_rest/10.
:- public reduced_rel_rest/10.
:- module_transparent reduced_rel_rest/10.

reduced_rel_rest(Agmt, Conj0, Rel0, Rel, _, Mask, A, B, C, D) :-
    conj(Conj0,
         Conj,
         Rel0,
         Rel1,
         Rel,
         A,
         E,
         C,
         F),
    reduced_rel_conj(Agmt,
                     Conj,
                     Rel1,
                     Mask,
                     E,
                     B,
                     F,
                     D).
reduced_rel_rest(_, _, Rel, Rel, Mask, Mask, A, B, C, D) :-
    noText(A, B, C, D).


:- dynamic reduced_rel/7.
:- multifile reduced_rel/7.
:- public reduced_rel/7.
:- module_transparent reduced_rel/7.

reduced_rel(Agmt, reduced_rel(X, S), Mask, A, B, C, D) :-
    mark_island(A, E, C, F),
    reduced_wh(Agmt, X, E, G, F, H),
    s80(S, Mask0, G, I, H, J),
    is_trace_bits(Trace),
    minus_mask(Mask0, Trace, Mask),
    mark_dnalsi(I, B, J, D).


:- dynamic reduced_wh/6.
:- multifile reduced_wh/6.
:- public reduced_wh/6.
:- module_transparent reduced_wh/6.

reduced_wh(Agmt, X, A, B, C, x(nogap, nonterminal, np(np(Agmt, wh(X), []), Agmt, NPCase, _, _, Set0, Mask0), x(nogap, nonterminal, verb_form88(MODAL, be(MODAL), pres+fin, Agmt, main), x(nogap, nonterminal, neg_modal_opt(MODAL, _, Neg), x(nogap, nonterminal, pred(Neg, Pred, Mask), D))))) :-
    neg_modal_opt(MODAL,
                  _,
                  Neg,
                  A,
                  E,
                  C,
                  F),
    pred(Neg, Pred, Mask, E, B, F, D),
    is_trace82(Set0, Mask0),
    is_subj_case(NPCase).
reduced_wh(Agmt, X, A, B, C, x(nogap, nonterminal, np(np(Agmt, wh(X), []), Agmt, NPCase, _, _, Set, Mask), x(nogap, nonterminal, verb(Verb, _, Type, Voice), D))) :-
    participle_vt(Verb,
                  Type,
                  Voice,
                  A,
                  B,
                  C,
                  D),
    is_trace82(Set, Mask),
    is_subj_case(NPCase).
reduced_wh(AgmtX, X, A, B, C, x(nogap, nonterminal, np(Subj, Agmt, SCase, Def, _, Set0, Mask0), x(gap, nonterminal, np(np(AgmtX, wh(X), []), AgmtX, VCase, _, _, Set, Mask), D))) :-
    is_s_all(SAll),
    is_subj_case(SCase),
    is_verb_case(VCase),
    np(Subj,
       Agmt,
       _,
       Def,
       subj,
       SAll,
       _,
       A,
       B,
       C,
       D),
    is_trace82(Set0, Mask0),
    is_trace82(Set, Mask).


:- dynamic verb/8.
:- multifile verb/8.
:- public verb/8.
:- module_transparent verb/8.

verb(A, B, C, D, E, E, F, G) :-
    virtual(verb(A, B, C, D), F, G).
verb(verb(Root, Voice, Time+fin, Aspect, Neg), Agmt, Type, Voice, A, B, C, D) :-
    verb_form88(MODAL,
                Root0,
                Time+fin,
                Agmt,
                Role,
                A,
                E,
                C,
                F),
    verb_type_lex(Root0, Type0),
    neg_modal_opt(MODAL,
                  Type0,
                  Neg,
                  E,
                  G,
                  F,
                  H),
    rest_verb(Role,
              Root0,
              Root,
              Voice,
              Aspect,
              G,
              B,
              H,
              D),
    verb_type_lex(Root, Type).


:- dynamic neg_modal_opt1/7.
:- multifile neg_modal_opt1/7.
:- public neg_modal_opt1/7.
:- module_transparent neg_modal_opt1/7.

neg_modal_opt1(MODAL, aux+_, negP(MODAL1), A, B, C, D) :-
    theText80(not, A, B, C, D),
    ignore(MODAL=MODAL1).
neg_modal_opt1(MODAL, _, posP(MODAL1), A, B, C, D) :-
    noText(A, B, C, D),
    ignore(MODAL=MODAL1).


:- dynamic maybe_modal/7.
:- multifile maybe_modal/7.
:- public maybe_modal/7.
:- module_transparent maybe_modal/7.

maybe_modal(A, B, C, D, E, F, G) :-
    modal_verb_form_aux(A, B, _, _),
    theText80(A, D, E, F, G),
    B=C.


:- dynamic rest_verb/9.
:- multifile rest_verb/9.
:- public rest_verb/9.
:- module_transparent rest_verb/9.

rest_verb(aux, have(MODAL), Root, Voice, [perf|Aspect], A, B, C, D) :-
    verb_form88(MODAL,
                Root0,
                past+part,
                _,
                _,
                A,
                E,
                C,
                F),
    have_vt(Root0,
            Root,
            Voice,
            Aspect,
            E,
            B,
            F,
            D).
rest_verb(aux, be(MODAL), Root, Voice, Aspect, A, B, C, D) :-
    verb_form88(MODAL,
                Root0,
                Tense0,
                _,
                _,
                A,
                E,
                C,
                F),
    be_vt(Tense0,
          Root0,
          Root,
          Voice,
          Aspect,
          E,
          B,
          F,
          D).
rest_verb(aux, do(MODAL), Root, active, [], A, B, C, D) :-
    verb_form88(MODAL,
                Root,
                inf,
                _,
                _,
                A,
                B,
                C,
                D).
rest_verb(main, Root, Root, active, [], A, B, C, D) :-
    noText(A, B, C, D).


:- dynamic have_vt/8.
:- multifile have_vt/8.
:- public have_vt/8.
:- module_transparent have_vt/8.

have_vt(be(MODAL), Root, Voice, Aspect, A, B, C, D) :-
    verb_form88(MODAL,
                Root0,
                Tense0,
                _,
                _,
                A,
                E,
                C,
                F),
    be_vt(Tense0,
          Root0,
          Root,
          Voice,
          Aspect,
          E,
          B,
          F,
          D).
have_vt(Root, Root, active, [], A, B, C, D) :-
    noText(A, B, C, D).


:- dynamic be_vt/9.
:- multifile be_vt/9.
:- public be_vt/9.
:- module_transparent be_vt/9.

be_vt(past+part, Root, Root, passive, [], A, B, C, D) :-
    noText(A, B, C, D).
be_vt(pres+part, Root0, Root, Voice, [prog], A, B, C, D) :-
    passive_vt(Root0,
               Root,
               Voice,
               A,
               B,
               C,
               D).


:- dynamic passive_vt/7.
:- multifile passive_vt/7.
:- public passive_vt/7.
:- module_transparent passive_vt/7.

passive_vt(be(MODAL), Root, passive, A, B, C, D) :-
    verb_form88(MODAL,
                Root,
                past+part,
                _,
                _,
                A,
                B,
                C,
                D),
    verb_type_lex(Root, Type),
    passive_vt(Type).
passive_vt(Root, Root, active, A, B, C, D) :-
    noText(A, B, C, D).


:- dynamic participle_vt/7.
:- multifile participle_vt/7.
:- public participle_vt/7.
:- module_transparent participle_vt/7.

participle_vt(verb(Root, Voice, inf, Aspect, Neg), Type, Voice, A, B, C, D) :-
    neg_modal_opt(MODAL,
                  _,
                  Neg,
                  A,
                  E,
                  C,
                  F),
    verb_form88(MODAL,
                Root,
                Tense,
                _,
                _,
                E,
                B,
                F,
                D),
    participle_vt(Tense, Voice, Aspect),
    verb_type_lex(Root, Type).


:- dynamic mark_dnalsi/4.
:- multifile mark_dnalsi/4.
:- public mark_dnalsi/4.
:- module_transparent mark_dnalsi/4.

mark_dnalsi(A, A, B, C) :-
    virtual(mark_dnalsi, B, C).


:- dynamic mark_island/4.
:- multifile mark_island/4.
:- public mark_island/4.
:- module_transparent mark_island/4.

mark_island(A, B, C, x(gap, nonterminal, mark_dnalsi, D)) :-
    noText(A, B, C, D).


:- dynamic verb_args/9.
:- multifile verb_args/9.
:- public verb_args/9.
:- module_transparent verb_args/9.

verb_args(_+Type, Voice, AdvArgs, Mask0, Mask, A, B, C, D) :-
    advs_opt(AdvArgs, Args, _, A, E, C, F),
    verb_args(Type,
              Voice,
              Args,
              Mask0,
              Mask,
              E,
              B,
              F,
              D).
verb_args(tv, active, [arg(dir, Dir)], _, Mask, A, B, C, D) :-
    verb_arg(np, Dir, Mask, A, B, C, D).
verb_args(dv(_Prep), _, [arg(Case, NP)|X], _, Mask, A, B, C, D) :-
    verb_arg(np, NP, Mask0, A, E, C, F),
    object_opt(Case,
               X,
               Mask0,
               Mask,
               E,
               B,
               F,
               D).
verb_args(be(_MODAL), _, [voidQ], Mask, Mask, A, B, C, D) :-
    theText80(there, A, B, C, D).
verb_args(be(_MODAL), _, [arg(pred, P)], _, Mask, A, B, C, D) :-
    pred_conj(_, P, Mask, A, B, C, D).
verb_args(be(_MODAL), _, [arg(dir, P)], _, Mask, A, B, C, D) :-
    verb_arg(np, P, Mask, A, B, C, D).
verb_args(have(_MODAL), active, [arg(dir, P)], _, Mask, A, B, C, D) :-
    verb_arg(np, P, Mask, A, B, C, D).
verb_args(Type, _, [], Mask, Mask, A, A, B, B) :-
    no_args_vt(Type).


:- dynamic object_opt/8.
:- multifile object_opt/8.
:- public object_opt/8.
:- module_transparent object_opt/8.

object_opt(Case, AdvArg, Mask0, Mask, A, B, C, D) :-
    adv_bits(Adv),
    minus_mask(Adv, Mask0, Mask1),
    advs_opt(AdvArg, X, Mask1, A, E, C, F),
    obj_opt(Case,
            X,
            Mask0,
            Mask,
            E,
            B,
            F,
            D).


:- dynamic obj_opt/8.
:- multifile obj_opt/8.
:- public obj_opt/8.
:- module_transparent obj_opt/8.

obj_opt(ind, [arg(dir, NP)], _, Mask, A, B, C, D) :-
    verb_arg(np, NP, Mask, A, B, C, D).
obj_opt(dir, [], Mask, Mask, A, B, C, D) :-
    noText(A, B, C, D).


:- dynamic pred_conj/7.
:- multifile pred_conj/7.
:- public pred_conj/7.
:- module_transparent pred_conj/7.

pred_conj(Conj, Arg, Mask, A, B, C, D) :-
    pred(_, Arg0, Mask0, A, E, C, F),
    pred_rest(Conj,
              Arg0,
              Arg,
              Mask0,
              Mask,
              E,
              B,
              F,
              D).


:- dynamic pred_rest/9.
:- multifile pred_rest/9.
:- public pred_rest/9.
:- module_transparent pred_rest/9.

pred_rest(Conj0, Arg0, Arg, _, Mask, A, B, C, D) :-
    conj(Conj0,
         Conj,
         Arg0,
         Arg1,
         Arg,
         A,
         E,
         C,
         F),
    pred_conj(Conj,
              Arg1,
              Mask,
              E,
              B,
              F,
              D).
pred_rest(_, Arg, Arg, Mask, Mask, A, B, C, D) :-
    noText(A, B, C, D).


:- dynamic verb_arg/7.
:- multifile verb_arg/7.
:- public verb_arg/7.
:- module_transparent verb_arg/7.

verb_arg(np, NP, Mask, A, B, C, D) :-
    is_s_all(SAll),
    is_verb_case(VCase),
    np(NP,
       _,
       VCase,
       _,
       compl,
       SAll,
       Mask,
       A,
       B,
       C,
       D).


:- dynamic advs_opt/7.
:- multifile advs_opt/7.
:- public advs_opt/7.
:- module_transparent advs_opt/7.

advs_opt([Adv|R0], R, Set, A, B, C, D) :-
    is_adv_bits(Set),
    adverb(Adv, A, E, C, F),
    advs_opt(R0, R, Set, E, B, F, D).
advs_opt(R, R, _, A, B, C, D) :-
    noText(A, B, C, D).


:- dynamic adj_phrase/6.
:- multifile adj_phrase/6.
:- public adj_phrase/6.
:- module_transparent adj_phrase/6.

adj_phrase(P, Nil, A, B, C, D) :-
    adj(_, P, A, B, C, D),
    is_empty_bits(Nil).
adj_phrase(P, Mask, A, B, C, D) :-
    comp_phrase(P, Mask, A, B, C, D).


:- dynamic conj/9.
:- multifile conj/9.
:- public conj/9.
:- module_transparent conj/9.

conj(conj(Conj, Ctx0), conj(Conj, Ctx), Left, Right, conj(Conj, Left, Right), A, B, C, D) :-
    conj(Conj, Ctx0, Ctx, A, B, C, D).


:- dynamic theTextL/7.
:- multifile theTextL/7.
:- public theTextL/7.
:- module_transparent theTextL/7.

theTextL(A, _, B=A, C, D, E, F) :-
    !,
    theTextL80(A, C, D, E, F),
    A=B.
theTextL(W1, _CYCPOS, WHY, A, B, C, D) :-
    theTextL80(W1, A, B, C, D),
    call(WHY).


:- dynamic w001/5.
:- multifile w001/5.
:- public w001/5.
:- module_transparent w001/5.

w001(Cmp, A, B, C, D) :-
    (   consume_spans_hack(A, E, C, F)
    ;   C=F,
        A=E
    ),
    next_as_word(E, G, F, H),
    !,
    terminal(Cmp, G, I, H, J),
    ignore(apw2(Cmp)),
    !,
    (   consume_spans_hack(I, B, J, D)
    ;   J=D,
        I=B
    ).


:- dynamic theText80_W2/6.
:- multifile theText80_W2/6.
:- public theText80_W2/6.
:- module_transparent theText80_W2/6.

theText80_W2(Text, L, A, B, C, D) :-
    w001(Cmp, A, B, C, D),
    compound(Cmp),
    !,
    Cmp=w(Text, L).


:- dynamic w01/5.
:- multifile w01/5.
:- public w01/5.
:- module_transparent w01/5.

w01(Text, B, C, D, E) :-
    w001(A, B, C, D, E),
    atomic(A),
    !,
    A=Text.
w01(Text, A, B, C, D) :-
    theText80_W2(Text, _, A, B, C, D).


:- dynamic w1/5.
:- multifile w1/5.
:- public w1/5.
:- module_transparent w1/5.

w1(Text, A, B, C, D) :-
    w01(Text, A, B, C, D).


:- dynamic noText/4.
:- multifile noText/4.
:- public noText/4.
:- module_transparent noText/4.

noText(A, B, C, D) :-
    consume_spans_hack(A, B, C, D).


:- dynamic consume_spans_hack/4.
:- multifile consume_spans_hack/4.
:- public consume_spans_hack/4.
:- module_transparent consume_spans_hack/4.

consume_spans_hack(A, B, C, D) :-
    terminal(Var, A, B, C, D),
    var(Var),
    !,
    fail.
consume_spans_hack(A, B, C, D) :-
    terminal(span(NV), A, E, C, F),
    nonvar(NV),
    !,
    parser_e2c:add_prev_span(span(NV)),
    consume_spans_hack(E, B, F, D).
consume_spans_hack(A, A, B, B).


:- dynamic theText80Penn/5.
:- multifile theText80Penn/5.
:- public theText80Penn/5.
:- module_transparent theText80Penn/5.

theText80Penn(A, B, C, D, E) :-
    atomic(A),
    !,
    theText80(A, B, C, D, E).
theText80Penn(Cmp, A, B, C, D) :-
    compound(Cmp),
    !,
    w001(Cmp, A, B, C, D).
theText80Penn(w(A, B), C, D, E, F) :-
    theText80_W2(A, G, C, D, E, F),
    B=G.


:- dynamic xg_with_text/6.
:- multifile xg_with_text/6.
:- public xg_with_text/6.
:- module_transparent xg_with_text/6.

xg_with_text(G1, Text, A, B, C, D) :-
    xg_and(G1, theText_cl(Text), A, B, C, D).


:- dynamic theText80/6.
:- multifile theText80/6.
:- public theText80/6.
:- module_transparent theText80/6.

theText80(W1, _CYCPOS, A, B, C, D) :-
    theText80(W1, A, B, C, D).


:- dynamic theTextL80/5.
:- multifile theTextL80/5.
:- public theTextL80/5.
:- module_transparent theTextL80/5.

theTextL80(Text, A, B, C, D) :-
    var(Text),
    dmsg(theText_DCG_VAR(Text)),
    !,
    theText_ol(Text, A, B, C, D).
theTextL80(Text, A, B, C, D) :-
    is_list(Text),
    !,
    theText_cl(Text, A, B, C, D).
theTextL80(DCG, A, B, C, D) :-
    !,
    nonvar(DCG),
    phraseXG(DCG, A, B, C, D).
theTextL80(Text, A, B, C, D) :-
    Text=@=[_|_],
    !,
    theText_ol(Text, A, B, C, D).
theTextL80(DCG, A, B, C, D) :-
    dmsg(theText_DCG(DCG)),
    dtrace,
    nonvar(DCG),
    phraseXG(DCG, A, B, C, D).


:- dynamic theText_ol/5.
:- multifile theText_ol/5.
:- public theText_ol/5.
:- module_transparent theText_ol/5.

theText_ol([W1, W2, W3], A, B, C, D) :-
    theText80(W1, A, E, C, F),
    theText80(W2, E, G, F, H),
    theText80(W3, G, B, H, D).
theText_ol([W1, W2], A, B, C, D) :-
    theText80(W1, A, E, C, F),
    theText80(W2, E, B, F, D).
theText_ol([W1], A, B, C, D) :-
    theText80(W1, A, B, C, D).


:- dynamic theText_cl/5.
:- multifile theText_cl/5.
:- public theText_cl/5.
:- module_transparent theText_cl/5.

theText_cl([], A, A, B, B) :-
    !.
theText_cl([W1|WL], A, B, C, D) :-
    theText80(W1, A, E, C, F),
    !,
    theText_cl(WL, E, B, F, D).


:- dynamic optText1/6.
:- multifile optText1/6.
:- public optText1/6.
:- module_transparent optText1/6.

optText1(_, _, A, B, C, D) :-
    noText(A, B, C, D).
optText1(W, POS, A, B, C, D) :-
    theText80(W, POS, A, B, C, D).


:- dynamic optText/5.
:- multifile optText/5.
:- public optText/5.
:- module_transparent optText/5.

optText(_Text, A, B, C, D) :-
    noText(A, B, C, D).
optText(Text, A, B, C, D) :-
    theTextL80(Text, A, B, C, D).


:- dynamic textOpt/5.
:- multifile textOpt/5.
:- public textOpt/5.
:- module_transparent textOpt/5.

textOpt(Text, A, B, C, D) :-
    theTextL80(Text, A, B, C, D).
textOpt(_Text, A, B, C, D) :-
    noText(A, B, C, D).


:- dynamic noun/6.
:- multifile noun/6.
:- public noun/6.
:- module_transparent noun/6.

noun(Noun, Agmt, A, B, C, D) :-
    theText80_W2(W, L, A, B, C, D),
    noun_form_wlex(L, W, Noun, Agmt).


:- dynamic adj/6.
:- multifile adj/6.
:- public adj/6.
:- module_transparent adj/6.

adj(Type, adj(Adj), A, B, C, D) :-
    theText80(Adj, A, B, C, D),
    adj_lex(Adj, Type).


:- dynamic prep/5.
:- multifile prep/5.
:- public prep/5.
:- module_transparent prep/5.

prep(prep(Prep), A, B, C, D) :-
    theText80(Prep, A, B, C, D),
    prep_lex(Prep).


:- dynamic comp_adj/5.
:- multifile comp_adj/5.
:- public comp_adj/5.
:- module_transparent comp_adj/5.

comp_adj(adj(Adj), A, B, C, D) :-
    theText80(RAdj, A, B, C, D),
    comp_adj_lex(RAdj, Adj).


:- dynamic sup_adj/5.
:- multifile sup_adj/5.
:- public sup_adj/5.
:- module_transparent sup_adj/5.

sup_adj(adj(Adj), A, B, C, D) :-
    theText80(SAdj, A, B, C, D),
    sup_adj_lex(SAdj, Adj).


:- dynamic comp_adv/5.
:- multifile comp_adv/5.
:- public comp_adv/5.
:- module_transparent comp_adv/5.

comp_adv(W, A, B, C, D) :-
    theText80(W, A, B, C, D),
    comp_adv_lex(W).


:- dynamic sup_adv/5.
:- multifile sup_adv/5.
:- public sup_adv/5.
:- module_transparent sup_adv/5.

sup_adv(W, A, B, C, D) :-
    theText80(W, A, B, C, D),
    sup_adv_lex(W).


:- dynamic rel_pron/5.
:- multifile rel_pron/5.
:- public rel_pron/5.
:- module_transparent rel_pron/5.

rel_pron(Case, A, B, C, D) :-
    theText80(W, A, B, C, D),
    rel_pron_lex(W, Case).


:- dynamic verb_form80/8.
:- multifile verb_form80/8.
:- public verb_form80/8.
:- module_transparent verb_form80/8.

verb_form80(Verb, Tense, Agmt, _Role, A, B, C, D) :-
    theText80_W2(W, L, A, B, C, D),
    verb_form_wlex(L, W, Verb, Tense, Agmt).


:- dynamic name_xg/5.
:- multifile name_xg/5.
:- public name_xg/5.
:- module_transparent name_xg/5.

name_xg(Name, A, B, C, D) :-
    opt_the(A, E, C, F),
    name_lex_txt(Name, E, B, F, D).


:- dynamic name_lex_txt/5.
:- multifile name_lex_txt/5.
:- public name_lex_txt/5.
:- module_transparent name_lex_txt/5.

name_lex_txt(Name, A, B, C, D) :-
    theText80(Name, A, B, C, D),
    name_LF(Name),
    !.
name_lex_txt(Name, A, B, C, D) :-
    theTextL80([W1, '_', W2], A, B, C, D),
    !,
    atomic(W1),
    atomic(W2),
    atomic_list_concat([W1, '_', W2], Name),
    name_LF(Name).
name_lex_txt(Name, A, B, C, D) :-
    theTextL80([W1, W2], A, B, C, D),
    atomic(W1),
    atomic(W2),
    atomic_list_concat([W1, '_', W2], Name),
    name_LF(Name).


:- dynamic int_art/7.
:- multifile int_art/7.
:- public int_art/7.
:- module_transparent int_art/7.

int_art(X, pl, quantV(same, wh(X)), A, B, C, D) :-
    how_many_lex(HOWMANY),
    theTextL80(HOWMANY, A, B, C, D).
int_art(X, Agmt, DX, A, B, C, D) :-
    theText80(Art, A, B, C, D),
    int_art_lex(Art, X, Agmt, DX).


:- dynamic int_pron/5.
:- multifile int_pron/5.
:- public int_pron/5.
:- module_transparent int_pron/5.

int_pron(Case, A, B, C, D) :-
    theText80(Pron, A, B, C, D),
    int_pron_lex(Pron, Case).


:- dynamic adverb/5.
:- multifile adverb/5.
:- public adverb/5.
:- module_transparent adverb/5.

adverb(adverb(W), A, B, C, D) :-
    theText80(W, A, B, C, D),
    adverb_lex(W).


:- dynamic poss_pron/6.
:- multifile poss_pron/6.
:- public poss_pron/6.
:- module_transparent poss_pron/6.

poss_pron(pronoun(Gender), Person+Number, A, B, C, D) :-
    theText80(W, A, B, C, D),
    poss_pron_lex(W, Gender, Person, Number).


:- dynamic pers_pron/7.
:- multifile pers_pron/7.
:- public pers_pron/7.
:- module_transparent pers_pron/7.

pers_pron(pronoun(Gender), Person+Number, Case, A, B, C, D) :-
    theText80(W, A, B, C, D),
    pers_pron_lex(W, Gender, Person, Number, Case).


:- dynamic quantifier_pron/6.
:- multifile quantifier_pron/6.
:- public quantifier_pron/6.
:- module_transparent quantifier_pron/6.

quantifier_pron(Det, Noun, A, B, C, D) :-
    theText80(W, A, B, C, D),
    quantifier_pron_lex(W, Det, Noun).


:- dynamic context_pron/6.
:- multifile context_pron/6.
:- public context_pron/6.
:- module_transparent context_pron/6.

context_pron(prep(In), Place, A, B, C, D) :-
    ctx_pron_lex(In, Place, Where),
    theText80(Where, A, B, C, D).


:- dynamic number/6.
:- multifile number/6.
:- public number/6.
:- module_transparent number/6.

number(I, Number, A, B, C, D) :-
    theText80(W, A, B, C, D),
    !,
    number_lex(W, I, Number).


:- dynamic terminator/5.
:- multifile terminator/5.
:- public terminator/5.
:- module_transparent terminator/5.

terminator(Type, A, B, C, D) :-
    theText80(Term, A, B, C, D),
    terminator_lex(Term, Type).


:- dynamic opt_the/4.
:- multifile opt_the/4.
:- public opt_the/4.
:- module_transparent opt_the/4.

opt_the(A, B, C, D) :-
    noText(A, B, C, D).
opt_the(A, B, C, D) :-
    theText80(the, A, B, C, D).


:- dynamic conj/7.
:- multifile conj/7.
:- public conj/7.
:- module_transparent conj/7.

conj(_, list, list, A, B, C, D) :-
    theText80(',', A, B, C, D).
conj(Conj, list, end, A, B, C, D) :-
    theText80(Conj, A, B, C, D),
    conj_lex(Conj).


:- dynamic loc_pred/6.
:- multifile loc_pred/6.
:- public loc_pred/6.
:- module_transparent loc_pred/6.

loc_pred(Of, P, A, B, C, D) :-
    theText80(W, A, B, C, D),
    loc_pred_lex(Of, W, P).


