
:- dynamic(direct_ss/4).

symmetric_pred(Spatial,B,X,C):- nonvar(X),nonvar(C),!,symmetric_direct(Spatial,B,X,C),!.
symmetric_pred(Spatial,B,X,C):- symmetric_direct(Spatial,B,X,C).

symmetric_direct(Spatial,B,X,C) :- direct_ss(Spatial,B,X,C).
symmetric_direct(Spatial,B,X,C) :- direct_ss(Spatial,B,C,X).

add_ss(Spatial,B,X,C):- X @> C, !, add_ss(Spatial,B,C,X).
add_ss(Spatial,B,X,C):- direct_ss(Spatial,B, X,C), !.
add_ss(Spatial,B,X,C):- assertz(direct_ss(Spatial,B, X,C)), !.

% NLU Logical Forms
% ------------------

% X rises in Begin
% % chat80("where does the rhine rise?") -> [switzerland]
% chat80("the rhine rises in switzerland ?      ").
% @TODO: X begins from Begin
intrans_LF(Start,SpatialType,X, LF,
   [slot(prep(In),Spatial&_,Begin,_,free)],_):- 
 type_begins_thru_ends(Type, PathSystem, Start, _Continue, _Stop),
 bfeature_path(Spatial,Type,SpatialType),member(In,[in,from,at]),
 LF = path_pred(begins(PathSystem),Type,X,Begin).

% X drains into End
intrans_LF(Stop,SpatialType,X, LF, 
   [slot(prep(Into),Spatial&_,End,_,free)],_):- 
 type_begins_thru_ends(Type, PathSystem, _Start, _Continue, Stop),
 bfeature_path(Spatial,Type,SpatialType),member(Into,[into,in,to,at]),
 LF = path_pred(ends(PathSystem),Type,X,End).

intrans_LF(Continue,SpatialType,X,LF,
   [slot(prep(Into),Spatial&_,Dest,_,free),
    slot(prep(From),Spatial&_,Origin,_,free)],_):- 
 type_begins_thru_ends(Type, PathSystem, _Start, Continue, _Stop),
 bfeature_path(Spatial,Type,SpatialType),
 member(Into,[into,to,through,in,at]),
 member(From,[from,through,in,at]), 
 dif(From,Into),
 LF = path_pred_linkage(direct(PathSystem),Type,X,Origin,Dest).

% X flows through Begin
/*
intrans_LF(Continue,SpatialType,X,LF,
   [slot(prep(Through),Spatial&_,Link,_,free)],_):- 
 type_begins_thru_ends(Type, PathSystem, _Start, Continue, _Stop),
 bfeature_path(Spatial,Type,SpatialType),member(Through,[through,in]),
 LF = path_pred(thru_from(PathSystem),Type,X,Link).
*/

% Logical Rules
% ------------------
ti(Type,Inst) :- 
 type_specific_bte(Type, PathSystem,_Start,_Continue, _Stop),
 path_nodes(PathSystem,Type,Inst,_L).

path_pred(begins(PathSystem),Type,R,C) :-
 %type_specific_bte(Type, PathSystem, Start,_Continue,_Stop),
 path_nodes(PathSystem,Type,R,L), last_node(L,C).

path_pred(ends(PathSystem),Type,R,S) :- 
 %type_specific_bte(Type, PathSystem,_Start, _Continue, Stop),
 path_nodes(PathSystem,Type,R,L), first_node(L,S).

path_pred(thru_from(PathSystem),Type,R,C) :-
 %type_specific_bte(Type, PathSystem,_Start, _Continue, _Stop),
 path_pred_linkage(direct(PathSystem),Type,R,C,_).

path_pred_linkage(direct(PathSystem),Type,R,C1,C2) :- 
 %type_specific_bte(Type, PathSystem,_Start, _PathSystem, _Stop),
 path_nodes(PathSystem,Type,R,L), node_pairs_direct(L,C2,C1).

path_pred_linkage(indirect(PathSystem),Type,R,C1,C2) :- 
 %type_specific_bte(Type, PathSystem,_Start, _PathSystem, _Stop),
 path_nodes(PathSystem,Type,R,L), node_pairs_indirect(L,C2,C1).

% Logical Rule Helpers
% ------------------
first_node([X|_],X).

last_node([X],X).
last_node([_|L],X) :- last_node(L,X).

node_pairs_direct([X1,X2|_],X1,X2).
node_pairs_direct([_|L],X1,X2) :- node_pairs_direct(L,X1,X2).

node_pairs_indirect(L,C2,C1):- 
  node_pairs_direct(L,C2,CM),
  (CM=C1;node_pairs_indirect(L,CM,C1)).

